"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

require("core-js/features/promise");

require("isomorphic-fetch");

// Backwards compatibility

/**
 * Base class for interfacing with a remote txtai service via REST API calls. 
 */
var API = /*#__PURE__*/function () {
  /**
   * Creates an API instance.
   * 
   * @param url base url
   */
  function API(url) {
    (0, _classCallCheck2["default"])(this, API);
    // Base url
    this.url = url;
  }
  /**
   * Executes a get request.
   * 
   * @param method api method
   * @param params query parameters
   * @return response
   */


  (0, _createClass2["default"])(API, [{
    key: "get",
    value: function () {
      var _get = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(method, params) {
        var url, res;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // Build URL
                url = "".concat(this.url, "/").concat(method);

                if (params) {
                  url += "?".concat(new URLSearchParams(params));
                } // Execute remote call


                _context.next = 4;
                return fetch(url);

              case 4:
                res = _context.sent;

                if (!res.ok) {
                  _context.next = 11;
                  break;
                }

                _context.next = 8;
                return res.json();

              case 8:
                _context.t0 = _context.sent;
                _context.next = 12;
                break;

              case 11:
                _context.t0 = Promise.reject("".concat(res.status, " ").concat(res.statusText));

              case 12:
                return _context.abrupt("return", _context.t0);

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function get(_x, _x2) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
    /**
     * Executes a post request.
     * 
     * @param method api method
     * @param params post parameters
     * @return response
     */

  }, {
    key: "post",
    value: function () {
      var _post = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(method, params) {
        var url, res;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                // Build URL
                url = "".concat(this.url, "/").concat(method); // Execute remote call

                _context2.next = 3;
                return fetch(url, {
                  method: "post",
                  body: JSON.stringify(params)
                });

              case 3:
                res = _context2.sent;

                if (!res.ok) {
                  _context2.next = 10;
                  break;
                }

                _context2.next = 7;
                return res.json();

              case 7:
                _context2.t0 = _context2.sent;
                _context2.next = 11;
                break;

              case 10:
                _context2.t0 = Promise.reject("".concat(res.status, " ").concat(res.statusText));

              case 11:
                return _context2.abrupt("return", _context2.t0);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function post(_x3, _x4) {
        return _post.apply(this, arguments);
      }

      return post;
    }()
  }]);
  return API;
}();

var _default = API;
exports["default"] = _default;
//# sourceMappingURL=api.js.map