"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _api = _interopRequireDefault(require("./api"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * txtai embeddings instance. 
 */
var Embeddings = /*#__PURE__*/function (_API) {
  (0, _inherits2["default"])(Embeddings, _API);

  var _super = _createSuper(Embeddings);

  function Embeddings() {
    (0, _classCallCheck2["default"])(this, Embeddings);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Embeddings, [{
    key: "search",
    value:
    /**
     * Finds documents in the embeddings model most similar to the input query. Returns
     * a list of {id: value, score: value} sorted by highest score, where id is the
     * document id in the embeddings model.
     * 
     * @param query query text
     * @param limit maximum results (defaults to 10)
     * @return list of {id: value, score: value}
     */
    function () {
      var _search = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(query) {
        var limit,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                limit = _args.length > 1 && _args[1] !== undefined ? _args[1] : 10;
                _context.next = 3;
                return this.get("search", {
                  query: query,
                  limit: limit
                })["catch"](function (e) {
                  throw e;
                });

              case 3:
                return _context.abrupt("return", _context.sent);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function search(_x) {
        return _search.apply(this, arguments);
      }

      return search;
    }()
    /**
     * Finds documents in the embeddings model most similar to the input queries. Returns
     * a list of {id: value, score: value} sorted by highest score per query, where id is
     * the document id in the embeddings model.
     *
     * @param queries queries text
     * @param limit maximum results (defaults to 10)
     * @return list of {id: value, score: value} per query
     */

  }, {
    key: "batchsearch",
    value: function () {
      var _batchsearch = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(queries) {
        var limit,
            _args2 = arguments;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                limit = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : 10;
                _context2.next = 3;
                return this.post("batchsearch", {
                  queries: queries,
                  limit: limit
                })["catch"](function (e) {
                  throw e;
                });

              case 3:
                return _context2.abrupt("return", _context2.sent);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function batchsearch(_x2) {
        return _batchsearch.apply(this, arguments);
      }

      return batchsearch;
    }()
    /**
     * Adds a batch of documents for indexing.
     * 
     * @param documents list of {id: value, text: value}
     */

  }, {
    key: "add",
    value: function () {
      var _add = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(documents) {
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.post("add", documents)["catch"](function (e) {
                  throw e;
                });

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function add(_x3) {
        return _add.apply(this, arguments);
      }

      return add;
    }()
    /**
     * Builds an embeddings index for previously batched documents. No further documents can be added
     * after this call.
     */

  }, {
    key: "index",
    value: function () {
      var _index = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.get("index", null)["catch"](function (e) {
                  throw e;
                });

              case 2:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function index() {
        return _index.apply(this, arguments);
      }

      return index;
    }()
    /**
     * Computes the similarity between query and list of text. Returns a list of
     * {id: value, score: value} sorted by highest score, where id is the index
     * in texts.
     *
     * @param query query text
     * @param texts list of text
     * @return list of {id: value, score: value}
     */

  }, {
    key: "similarity",
    value: function () {
      var _similarity = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(query, texts) {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.post("similarity", {
                  query: query,
                  texts: texts
                })["catch"](function (e) {
                  throw e;
                });

              case 2:
                return _context5.abrupt("return", _context5.sent);

              case 3:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function similarity(_x4, _x5) {
        return _similarity.apply(this, arguments);
      }

      return similarity;
    }()
    /**
     * Computes the similarity between list of queries and list of text. Returns a list
     * of {id: value, score: value} sorted by highest score per query, where id is the
     * index in texts.
     * 
     * @param queries queries text
     * @param texts list of text
     * @return list of {id: value, score: value} per query
     */

  }, {
    key: "batchsimilarity",
    value: function () {
      var _batchsimilarity = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(queries, texts) {
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.post("batchsimilarity", {
                  queries: queries,
                  texts: texts
                })["catch"](function (e) {
                  throw e;
                });

              case 2:
                return _context6.abrupt("return", _context6.sent);

              case 3:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function batchsimilarity(_x6, _x7) {
        return _batchsimilarity.apply(this, arguments);
      }

      return batchsimilarity;
    }()
    /**
     * Transforms text into an embeddings array.
     *
     * @param text input text
     * @return embeddings array
     */

  }, {
    key: "transform",
    value: function () {
      var _transform = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(text) {
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.get("transform", {
                  text: text
                })["catch"](function (e) {
                  throw e;
                });

              case 2:
                return _context7.abrupt("return", _context7.sent);

              case 3:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function transform(_x8) {
        return _transform.apply(this, arguments);
      }

      return transform;
    }()
    /**
     * Transforms list of text into embeddings arrays.
     *
     * @param texts list of text
     * @return embeddings array
     */

  }, {
    key: "batchtransform",
    value: function () {
      var _batchtransform = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(texts) {
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this.post("batchtransform", texts)["catch"](function (e) {
                  throw e;
                });

              case 2:
                return _context8.abrupt("return", _context8.sent);

              case 3:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function batchtransform(_x9) {
        return _batchtransform.apply(this, arguments);
      }

      return batchtransform;
    }()
  }]);
  return Embeddings;
}(_api["default"]);

var _default = Embeddings;
exports["default"] = _default;
//# sourceMappingURL=embeddings.js.map