"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _api = _interopRequireDefault(require("./api"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * txtai labels instance. 
 */
var Labels = /*#__PURE__*/function (_API) {
  (0, _inherits2["default"])(Labels, _API);

  var _super = _createSuper(Labels);

  function Labels() {
    (0, _classCallCheck2["default"])(this, Labels);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Labels, [{
    key: "label",
    value:
    /**
     * Applies a zero shot classifier to text using a list of labels. Returns a list of
     * {id: value, score: value} sorted by highest score, where id is the index in labels.
     * 
     * @param text input text
     * @param labels list of labels
     * @return list of {id: value, score: value} per text element
     */
    function () {
      var _label = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(text, labels) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.post("label", {
                  text: text,
                  labels: labels
                })["catch"](function (e) {
                  throw e;
                });

              case 2:
                return _context.abrupt("return", _context.sent);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function label(_x, _x2) {
        return _label.apply(this, arguments);
      }

      return label;
    }()
    /**
     * Applies a zero shot classifier to list of text using a list of labels. Returns a list of
     * {id: value, score: value} sorted by highest score, where id is the index in labels per
     * text element.
     *
     * @param texts list of texts
     * @param labels list of labels
     * @return list of {id: value score: value} per text element
     */

  }, {
    key: "batchlabel",
    value: function () {
      var _batchlabel = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(texts, labels) {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.post("batchlabel", {
                  texts: texts,
                  labels: labels
                })["catch"](function (e) {
                  throw e;
                });

              case 2:
                return _context2.abrupt("return", _context2.sent);

              case 3:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function batchlabel(_x3, _x4) {
        return _batchlabel.apply(this, arguments);
      }

      return batchlabel;
    }()
  }]);
  return Labels;
}(_api["default"]);

var _default = Labels;
exports["default"] = _default;
//# sourceMappingURL=labels.js.map