"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _api = _interopRequireDefault(require("./api"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * txtai summary instance. 
 */
var Summary = /*#__PURE__*/function (_API) {
  (0, _inherits2["default"])(Summary, _API);

  var _super = _createSuper(Summary);

  function Summary() {
    (0, _classCallCheck2["default"])(this, Summary);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Summary, [{
    key: "summary",
    value:
    /**
     * Runs a summarization model against a block of text.
     *
     * @param text text to summarize
     * @param minlength minimum length for summary
     * @param maxlength maximum length for summary
     * @return summary text
     */
    function () {
      var _summary = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(text, minlength, maxlength) {
        var params;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                params = {
                  text: text
                };

                if (minlength) {
                  params.minlength = minlength;
                }

                if (maxlength) {
                  params.maxlength = maxlength;
                }

                _context.next = 5;
                return this.get("summary", params)["catch"](function (e) {
                  throw e;
                });

              case 5:
                return _context.abrupt("return", _context.sent);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function summary(_x, _x2, _x3) {
        return _summary.apply(this, arguments);
      }

      return summary;
    }()
    /**
     * Runs a summarization model against a block of text.
     *
     * @param texts list of text to summarize
     * @param minlength minimum length for summary
     * @param maxlength maximum length for summary
     * @return list of summary text
     */

  }, {
    key: "batchsummary",
    value: function () {
      var _batchsummary = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(texts, minlength, maxlength) {
        var params;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                params = {
                  texts: texts
                };

                if (minlength) {
                  params.minlength = minlength;
                }

                if (maxlength) {
                  params.maxlength = maxlength;
                }

                _context2.next = 5;
                return this.post("batchsummary", params)["catch"](function (e) {
                  throw e;
                });

              case 5:
                return _context2.abrupt("return", _context2.sent);

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function batchsummary(_x4, _x5, _x6) {
        return _batchsummary.apply(this, arguments);
      }

      return batchsummary;
    }()
  }]);
  return Summary;
}(_api["default"]);

var _default = Summary;
exports["default"] = _default;
//# sourceMappingURL=summary.js.map